#!/bin/bash

if [ $# -lt 1 -o "$1" = "-h" -o "$1" = "--help" ]
then
  echo "Usage: $0 path_to_binary"
  echo "This script runs executable in clear environment"
  [ $# -ge 1 ]
  exit $?
fi

#create sandbox
SANDBOX=$(mktemp -d /tmp/sandbox-XXXXXX)

cd $SANDBOX
cp "$1" .
echo "Sandbox $SANDBOX created"

PROG=$(basename $1)
shift

# prevent information leak in variables, unset them all
unset $(env | cut -d '=' -f 1)

# TODO: Write SELinux rules to prevent application leaving this sandbox
echo "Executing..."
./$PROG $@
echo "Clean up"

cd /
rm -rf $SANDBOX
