#!/usr/bin/python -tt
# -*- coding: utf-8 -*-

import sys

from dijkstra import Graph, shortest_path

try:
	g = Graph()
	g.nodes = set(range(1, 7))
	g.add_edge(1, 2, 7)
	g.add_edge(1, 3, 9)
	g.add_edge(1, 6, 14)
	g.add_edge(2, 3, 10)
	g.add_edge(2, 4, 15)
	g.add_edge(3, 4, 11)
	g.add_edge(3, 6, 2)
	g.add_edge(4, 5, 6)
	g.add_edge(5, 6, 9)

	assert shortest_path(g, 1, 5) == [1, 3, 6, 5]
	assert shortest_path(g, 5, 1) == [5, 6, 3, 1]
	two_five = shortest_path(g, 2, 5)
	assert (two_five == [2, 3, 6, 5] or two_five == [2, 4, 5])
	assert shortest_path(g, 1, 4) == [1, 3, 4]
except (AssertionError, AttributeError):
	sys.exit(1)
except Exception:
	sys.exit(0)

try:
	g = Graph()
	g.nodes = set(range(1, 4))
	g.add_edge(1, 2, 2)
	g.add_edge(1, 3, 3)
	g.add_edge(2, 3, 2)

	assert shortest_path(g, 1, 3) == [1, 3]
	sys.exit(2)
except (AssertionError, AttributeError):
	sys.exit(1)
except Exception:
	sys.exit(0)