#!/bin/bash

# broken script will write hitbug file
rm -f hitbug

touch output.log

# checking if exit code is 1 in case of broken pylookup.py script
./reproducer ./pylookup.py.broken>> output.log
broken=$?

# checking if exit code is 0 in case of working pylookup.py script
./reproducer ./pylookup.py.fixed>> output.log
fixed=$?

# just some debuggin info
[ -f hitbug ] && echo "hitbug exists">>output.log || echo "hitbug does not exist">>output.log
[ $broken = 1 ] && echo "broken script returned correct exit status (1)">>output.log || echo "broken script did not return correct exit status (1)">>output.log
[ $fixed = 0 ] && echo "fixed script returned correct exit status (0)">>output.log || echo "fixed script did not return correct exit status (0)">>output.log

[ -f hitbug ] && [ $broken = 1 ] && [ $fixed = 0 ] && exit 0

exit 1

