#!/usr/bin/python -tt
# -*- coding: utf-8 -*-

import os
import sys
import subprocess

# test if user does not substitute the broken binary
try:
    output = subprocess.check_output(["./repoquery", "--version"], stderr=subprocess.STDOUT)
    broken_string = "Broken version for Bughunting contest of Open House 2013"
    if broken_string not in output:
        sys.exit(0)
except Exception:
    sys.exit(0)

try:
    # run command that checks dependencies of yum-utils
    output = subprocess.check_output(["./repoquery", "-R", "yum-utils"], stderr=subprocess.STDOUT)
    """
    F18:
        /usr/bin/python
        python(abi) = 2.7
        python-kitchen
        yum >= 3.2.29
    RHEL6:
        /usr/bin/python
        python >= 2.4
        python(abi) = 2.6
        yum >= 3.2.29
    """
    return_code = 0
except subprocess.CalledProcessError, ex:
    output = ex.output
    return_code = ex.return_code
except Exception:
    sys.exit(0)
# get rid of whitespace at the begining and end
output = output.strip()

# check of first problem
if "requiress" in output:
    sys.exit(0)
else:
    python_found = 0
    yum_found = False
    # check of second one
    for o in output.split('\n'):
        if 'python(abi)' in o:
            python_found += 1
        elif "/usr/bin/python" in o:
            python_found += 1
        elif "yum" in o:
            yum_found = True
    if python_found != 2 or not yum_found:
        sys.exit(1)

# detect cheaters, run similar command for different package
output = subprocess.check_output(["./repoquery", "-R", "yum"], stderr=subprocess.STDOUT)
"""
F18:
    /usr/bin/python
    pygpgme
    pyliblzma
    python >= 2.4
    python(abi) = 2.7
    python-iniparse
    python-sqlite
    python-urlgrabber >= 3.9.0-8
    pyxattr
    rpm >= 4.4.2
    rpm-python
    yum-metadata-parser >= 1.1.0

RHEL6:
    /usr/bin/python
    config(yum) = 3.2.29-40.el6
    pygpgme
    python >= 2.4
    python(abi) = 2.6
    python-iniparse
    python-sqlite
    python-urlgrabber >= 3.9.0-8
    rpm >= 4.4.2
    rpm-python
    yum-metadata-parser >= 1.1.0
"""

output = output.strip()

# check of first problem
if "requiress" in output:
    sys.exit(0)
else:
    python_found = 0
    rpm_found = 0
    # check of second one
    for o in output.split('\n'):
        if 'python(abi)' in o:
            python_found += 1
        elif "/usr/bin/python" in o:
            python_found += 1
        elif "rpm" in o:
            rpm_found += 1
        elif "rpm-python" in o:
            rpm_found += 1
    if python_found == 2 and rpm_found == 2:
        sys.exit(2)
    else:
        sys.exit(1)
