#!/bin/sh

set -x
MALLOC_PERTURB_=155 ./termname || exit $?
test 1 = "$(./termname | wc -l)" || exit $?
test 0 -lt "$(./termname | wc -c)" || exit $?
valgrind --leak-check=full --error-exitcode=42 ./termname

gcc -xc -lcurses - <<SRC
#include <stdio.h>
#include <stdlib.h>
#include <curses.h>

int main()
{
    char *term;

    /* init curses mode */
    if (!initscr())
        return EXIT_FAILURE;

    /* read terminal name */
    term = (void *)(long)longname();

    /* end curses mode */
    endwin();

    if (!term)
        return EXIT_FAILURE;

    /* print terminal name */
    printf("%s\n", term);
    return EXIT_SUCCESS;
}
SRC

test "`./termname`" = "`./a.out`"
